import functools as ft
from input_time import *
from itertools import chain, combinations 



def subset(a):
    lis=[]
    for n in range(2**len(a)):
        lis.append([a[i] for i in range(len(a)) if (n >> i) & 1 == 1])
    return lis

    
def powerset(S):
    lis=[]
    for subset in chain.from_iterable(combinations(S,r) for r in range(0,len(S)+1)):
        lis.append(list(subset))
    return lis

def powerset1(S):
    lis=[]
    for subset in chain.from_iterable(combinations(S,r) for r in range(1,len(S)+1)):
        lis.append(list(subset))
    return lis

    
def family1(S):
    lis=[]
    Lis=[]
    for subset in chain.from_iterable(combinations(S,r) for r in range(1,len(S)+1)):
        lis.append(subset)
    lis1=[list(lis[i]) for i in range(len(lis))]
    for subset in chain.from_iterable(combinations(lis1,r) for r in range(1, len(lis)+1)):
        Lis.append(list(subset))
    return Lis
    


def inter(a,b):
    lis=[]
    for i in a:
        if i in b:
            lis.append(i)
    return lis

def intersect(X):
    return ft.reduce(inter,X)


def family(S):
    lis=[]
    Lis=[]
    for subset in chain.from_iterable(combinations(S,r) for r in range(0,len(S)+1)):
        lis.append(subset)
    lis1=[list(lis[i]) for i in range(len(lis))]
    for subset in chain.from_iterable(combinations(lis1,r) for r in range(1, len(lis)+1)):
        Lis.append(list(subset))
    return Lis
        
def setminus(i,S=DM):
    S0=list(S)
    if i in S:
        S0.remove(i)
        return S0
    else:
        return S

def minusset(X,Y):
    return list(set(Y).difference(set(X)))

def clsminus(H,S=DM):
    result=[]
    for K in powerset1(S):
        if intersect([H,K])==[]:
            result.append(K)
    return result

def tclsminus(cls,S=DM):
    lis=[]
    for sets in cls:
        if sets==[]:
            return S
        else:
            for k in range(len(sets)):
                lis.append(sets[k])
    return list(minusset(set(lis),S))


def psetminus(H,S):
    if isinstance(H,list):
        return powerset1(list(set(S)-set(H)))
    else:
        H0=[]
        H0.append(H)
        return powerset1(list(set(S)-set(H0)))    

def coalinclu(i,S=DM):
    lis=[]
    if isinstance(i,list):
        seti=set(i)
        for j in powerset(S):
            if seti.issubset(j):
                lis.append(list(j))
        return lis
    else:    
        for k in range(0,len(powerset(S))):
            if i in powerset(S)[k]:
                lis.append(powerset(S)[k])
        return lis



def mat2lis(i,A,S):
    lis=[]
    for j in S:
        if A[i-1][j-1]==1:
            lis.append(j)
    return lis

def lis_sum(lis):
    return sum(lis)
