'''
Created on 2016/02/05

@author: takumi_lab
'''
import sys
import sympy as sy


#from input_time import *
from input_time import * 
from setop import *
from matrixop import *
from timeop import *
"""from stabilities import *"""
from time_stabilities import *



#concepts=["tNash","tNashc","tGMR","tGMRc","tcGMR","tcGMRc","tSMR","tSMRc","tcSMR","tcSMRc","tSEQ","tSEQc","tcSEQ","tcSEQc"]
#coal_concepts=["tCNash","tCNashc","tCGMR","tCGMRc","tcCGMR","tcCGMRc","tCSMR","tCSMRc","tcCSMR","tcCSMRc","tCSEQ","tCSEQc","tcCSEQ","tcCSEQc"]
concepts=["Nash","GMR","SMR","SEQ","tNash","tNashc","tGMR","tGMRc","tcGMR","tcGMRc","tSMR","tSMRc","tcSMR","tcSMRc","tSEQ","tSEQc","tcSEQ","tcSEQc"]
coal_concepts=["CNash","CGMR","CSMR","CSEQ","tCNash","tCNashc","tCGMR","tCGMRc","tcCGMR","tcCGMRc","tCSMR","tCSMRc","tcCSMR","tcCSMRc","tCSEQ","tCSEQc","tcCSEQ","tcCSEQc"]
st="_state"
eq="_eq"

tstabs=[concepts[i]+st for i in range(len(concepts))]
eqm=[concepts[i]+eq for i in range(len(concepts))]

ctstabs=[coal_concepts[i]+st for i in range(len(coal_concepts))]
ceqm=[coal_concepts[i]+eq for i in range(len(coal_concepts))]

import time_stabilities

"""
print("Stabilities for DM")
print()
for k in range(len(concepts)):
    func=getattr(time_stabilities,tstabs[k])
    eqs=getattr(time_stabilities,eqm[k])
    print("*** {0} ***".format(tstabs[k]))
    for i in DM:
        print("for DM{0}, {1}".format(i,func(i)))
    print("Equilibria :{0}".format(eqs()))
    print()

print()
print("Stabilities for Coalition")
print()
for k in range(len(coal_concepts)):
    func=getattr(time_stabilities,ctstabs[k])
    eqs=getattr(time_stabilities,ceqm[k])
    print("*** {0} ***".format(ctstabs[k]))
    for H in powerset1(DM):
        print("for coalition{0}, {1}".format(H,func(H)))
    for i in DM:
        print("for DM{0}, {1}".format(i,func(i)))        
    print("Equilibrium :{0}".format(eqs()))
    print()
"""
############################# for LaTeX #############################
#"""
import codecs
f = codecs.open("Result_case1_170119.tex", "w", "utf-8")
#import codecs
#f = codecs.open("Result.tex", "w", "utf-8")
#print(result(), file=f)
def output():
    print('What is inputed:')
    print('DM={0}'.format(DM))
    print('States={0}'.format(State))
    print('Graphs={0}'.format(graphs))
    print('Times={0}'.format(times))
    print('$m,u,l={0},{1},{2}$'.format(m,u,l) ,file=f)
    print('$m,u,l={0},{1},{2}$'.format(m,u,l))

def result():
    for k in range(len(concepts)):
        func=getattr(time_stabilities,tstabs[k])
        eqs=getattr(time_stabilities,eqm[k])
        print("\\begin{{tabular}}{{c|{0}}}\hline".format("".join(["c" for i in range(len(DM)+1)])) ,file=f)
        print("\\begin{{tabular}}{{c|{0}}}\hline".format("".join(["c" for i in range(len(DM)+1)])))
        print("\multirow{{3}}{{*}}{{States}} & \multicolumn{{{0}}}{{c}}{{{1}}}\\\\ \cline{{2-{2}}}".format(len(DM)+1,concepts[k],len(DM)+2) ,file=f)
        print("\multirow{{3}}{{*}}{{States}} & \multicolumn{{{0}}}{{c}}{{{1}}}\\\\ \cline{{2-{2}}}".format(len(DM)+1,concepts[k],len(DM)+2))
        print("& \multicolumn{{{0}}}{{c}}{{DM}}".format(len(DM))+"\\\\\cline{{2-{0}}}".format(len(DM)+1) ,file=f)    
        print("& \multicolumn{{{0}}}{{c}}{{DM}}".format(len(DM))+"\\\\\cline{{2-{0}}}".format(len(DM)+1))    
        print( " & " + " & ".join([str(i) for i in DM])+ " & Eq \\\\\hline" ,file=f)
        print( " & " + " & ".join([str(i) for i in DM])+ " & Eq \\\\\hline")
        for state in State:
            print("{0} & ".format(state) + " & ".join([str("$\circ$") if (state in func(i)) else str("{}") for i in DM]) + " & "+"".join([str("$\circ$") if (state in eqs()) else "{}"]) + "\\\\\hline" ,file=f)
            print("{0} & ".format(state) + " & ".join([str("$\circ$") if (state in func(i)) else str("{}") for i in DM]) + " & "+"".join([str("$\circ$") if (state in eqs()) else "{}"]) + "\\\\\hline" )
        print("\end{tabular}" ,file=f)
        print("\end{tabular}")
        print("\\\\" ,file=f)
        print("\\\\")
    print()
    for k in range(len(coal_concepts)):
        func=getattr(time_stabilities,ctstabs[k])
        eqs=getattr(time_stabilities,ceqm[k])
        print("\\begin{{tabular}}{{c|{0}}}\hline".format("".join(["c" for i in range(len(DM)+1)])) ,file=f)
        print("\\begin{{tabular}}{{c|{0}}}\hline".format("".join(["c" for i in range(len(DM)+1)])))
        print("\multirow{{3}}{{*}}{{States}} & \multicolumn{{{0}}}{{c}}{{{1}}}\\\\ \cline{{2-{2}}}".format(len(DM)+1,coal_concepts[k],len(DM)+2) ,file=f)
        print("\multirow{{3}}{{*}}{{States}} & \multicolumn{{{0}}}{{c}}{{{1}}}\\\\ \cline{{2-{2}}}".format(len(DM)+1,coal_concepts[k],len(DM)+2))
        print("& \multicolumn{{{0}}}{{c}}{{DM}}".format(len(DM))+"\\\\\cline{{2-{0}}}".format(len(DM)+1) ,file=f)    
        print("& \multicolumn{{{0}}}{{c}}{{DM}}".format(len(DM))+"\\\\\cline{{2-{0}}}".format(len(DM)+1))    
        print( " & " + " & ".join([str(i) for i in DM])+ " & Eq \\\\\hline" ,file=f)
        print( " & " + " & ".join([str(i) for i in DM])+ " & Eq \\\\\hline")
        for state in State:
            print("{0} & ".format(state) + " & ".join([str("$\circ$") if (state in func(i)) else str("{}") for i in DM]) + " & "+"".join([str("$\circ$") if (state in eqs()) else "{}"]) + "\\\\\hline" ,file=f)
            print("{0} & ".format(state) + " & ".join([str("$\circ$") if (state in func(i)) else str("{}") for i in DM]) + " & "+"".join([str("$\circ$") if (state in eqs()) else "{}"]) + "\\\\\hline")
        print("\end{tabular}" ,file=f)
        print("\end{tabular}")
        print("\\\\" ,file=f)
        print("\\\\")

def calculate():
    output()
    print()
    print("Calculating...")
    result()
    print("Done!!")

calculate()
"""
import time_stabilities
def result():
    for k in range(len(concepts)):
        func=getattr(time_stabilities,tstabs[k])
        eqs=getattr(time_stabilities,eqm[k])
        print("\\begin{{tabular}}{{c|{0}}}\hline".format("".join(["c" for i in range(len(DM)+1)])))
        print("\multirow{{3}}{{*}}{{States}} & \multicolumn{{{0}}}{{c}}{{{1}}}\\\\ \cline{{2-{2}}}".format(len(DM)+1,concepts[k],len(DM)+2))
        print("& \multicolumn{{{0}}}{{c}}{{DM}}".format(len(DM))+"\\\\\cline{{2-{0}}}".format(len(DM)+1))    
        print( " & " + " & ".join([str(i) for i in DM])+ " & Eq \\\\\hline")
        for state in State:
            print("{0} & ".format(state) + " & ".join([str("$\circ$") if (state in func(i)) else str("{}") for i in DM]) + " & "+"".join([str("$\circ$") if (state in eqs()) else "{}"]) + "\\\\\hline")
        print("\end{tabular}")
        print("\\\\")
    print()
    for k in range(len(coal_concepts)):
        func=getattr(time_stabilities,ctstabs[k])
        eqs=getattr(time_stabilities,ceqm[k])
        print("\\begin{{tabular}}{{c|{0}}}\hline".format("".join(["c" for i in range(len(DM)+1)])))
        print("\multirow{{3}}{{*}}{{States}} & \multicolumn{{{0}}}{{c}}{{{1}}}\\\\ \cline{{2-{2}}}".format(len(DM)+1,coal_concepts[k],len(DM)+2))
        print("& \multicolumn{{{0}}}{{c}}{{DM}}".format(len(DM))+"\\\\\cline{{2-{0}}}".format(len(DM)+1))    
        print( " & " + " & ".join([str(i) for i in DM])+ " & Eq \\\\\hline")
        for state in State:
            print("{0} & ".format(state) + " & ".join([str("$\circ$") if (state in func(i)) else str("{}") for i in DM]) + " & "+"".join([str("$\circ$") if (state in eqs()) else "{}"]) + "\\\\\hline")
        print("\end{tabular}")
        print("\\\\")
result()

"""



"""
for i in DM:
    for k in range(len(concepts)):
        func=getattr(time_stabilities,tstabs[k])
        print("{0} {1} {2} for DM {3}".format(tstabs[k], ("is" if len(func(i))==1  else "are"),func(i),i))
"""

